PHP异常处理

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/asty9000/article/details/80870411
        PHP5提供了一种与其他语言类似的异常处理模型,异常处理是指在指定的错误(异常)情况发生时改变脚本的正常流程。在PHP中异常可以被抛出并被捕获。
        通过将代码放到try块中来捕获潜在的异常,异常必须是Exception或其子类的实例。
        可以使用多个catch块来捕获不同种类的异常,如果try块没有抛出异常,将会在最后一个被定义的catch块之后继续执行。catch块中可以抛出原本的异常,也可以重新抛出新的异常。抛出异常时,产生异常的语句后面的代码不会执行,PHP会尝试找到第一个匹配的catch块。如果异常没有被捕获,并且没有使用set_exception_handler()做相应的处理,将产生致命错误,并输出“Uncaught Exception”的错误信息。
        PHP5.5起,可以在最后一个catch块后面定义一个finally块,无论是否发生异常在try和catch代码块中的代码执行完之后总是会执行finally块中的代码 。
        PHP内部函数主要使用错误报告,只有面向对象的扩展使用异常,但是错误可以通过ErrorException简单的将错误转换为异常。PHP提供了一些常用的内置异常。
<?php
function handleException($exception){
	 echo "Uncaught exception: " , $exception->getMessage(), "\n";
}
set_exception_handler("handleException");

function foo($i){
	if($i){
		echo 1/$i."\n";
	}else{
		throw new Exception("divisor is zero");
	}
}

try {
    foo(5);
    foo(0);
} catch (Exception $e) {
	echo 'Caught exception: ',  $e->getMessage(), "\n";
	throw new Exception("new Exception thrown by catch block");	
}finally{
	echo "finally block\n";
}
?>

展开阅读全文

没有更多推荐了,返回首页